#!/bin/sh
if [ "X$1" = "X" ] ; then
    echo "Usage: update.sh [ip address]"
    exit;
fi
cd /tmp/
tftp -g -r install.sh $1 ; chmod a+x /tmp/install.sh; /tmp/install.sh $1; exit;
killall -2 exgined
sleep 1

cat /proc/flash_write_enable
mount -o remount,rw /mnt/flash

echo Updating EXGINE software ...
HOST=$1
FILES="dsp_lkm.o fpga_lkm.o gpio_lkm.o fp_lkm.o exgined user_if dsp.bin dsp_am.bin \
      init.sh update.sh exgine.cfg www/index.html www/countdown.js \
      www/nautel_logo.jpg"
	
echo   Downloading files from $HOST ...
cd /tmp/
install -d www
for FILE in $FILES
do
	tftp -g -r $FILE $HOST
	if [ -e $FILE ] ; then	
		echo "  Fetching $FILE ...";
		# get file size
		SIZE=`ls -s $FILE`;
		for S in $SIZE
		do
			if [ $S = "0" ]; then
				echo "$FILE did not transfer (0 bytes) ... aborting."
				exit
			fi
		done
	else
		echo $FILE did not transfer ... aborting software update.
		exit
	fi
done

echo   Copying files to FLASH ...
install -d /mnt/flash/www
if [ -e /mnt/flash/exgine.cfg ] ; then 
    cp /mnt/flash/exgine.cfg /mnt/flash/exgine.cfg.bkup
fi

for FILE in $FILES
do
	echo "  Installing $FILE ...";
	cp -f $FILE /mnt/flash/$FILE
done

cd /mnt/flash
chmod a+x exgined
chmod a+x user_if
chmod a+x init.sh
chmod a+x update.sh
sync
mount -o remount,ro /mnt/flash
cat /proc/flash_write_disable
echo Update complete.
