#!/bin/sh
echo "Content-type: text/html";
echo;
echo "<HTML><TITLE>Edit E2X Transport Mode</TITLE><BODY>";
cd /mnt/flash

errMsg="<BR>Please use your browser's <B>back</B> button to correct the error.<BR>";

#
# Read CGI data
#
read data_in

#
# Parse the input data
#
if [ "X$data_in" != "X" ]; then




#newExgineMode
#newAmSrvMode
#newAmAnalogGain
#newAmAnalogEnable
#newAmIqScaleFactor
#newAmDcOffset
#newAmDelay
#newAmPriUpperLvlAdjdB
#newAmPriLowerLvlAdjdB
#newAmAnalogAudioBandwith
#newAmEnhancedPowerLevel
#newAmInterpolationFactor

	#
	# Input checking
	#
	#echo "Got $data_in"
	newExgineMode=`echo $data_in | sed -n "s/.*\(newExgineMode=\)\([^\&]*\).*/\2/p"`
	newAmSrvMode=`echo $data_in | sed -n "s/.*\(newAmSrvMode=\)\([^\&]*\).*/\2/p"`
	newAmAnalogGain=`echo $data_in | sed -n "s/.*\(newAmAnalogGain=\)\([^\&]*\).*/\2/p"`
	newDabEnable=`echo $data_in | sed -n "s/.*\(newDabEnable=\)\([^\&]*\).*/\2/p"`
	newAmAnalogEnable=`echo $data_in | sed -n "s/.*\(newAmAnalogEnable=\)\([^\&]*\).*/\2/p"`
	newAmIqScaleFactor=`echo $data_in | sed -n "s/.*\(newAmIqScaleFactor=\)\([^\&]*\).*/\2/p"`
	newAmDcOffset=`echo $data_in | sed -n "s/.*\(newAmDcOffset=\)\([^\&]*\).*/\2/p"`
	newAmDelay=`echo $data_in | sed -n "s/.*\(newAmDelay=\)\([^\&]*\).*/\2/p"`
	newAmPriUpperLvlAdjdB=`echo $data_in | sed -n "s/.*\(newAmPriUpperLvlAdjdB=\)\([^\&]*\).*/\2/p"`
	newAmPriLowerLvlAdjdB=`echo $data_in | sed -n "s/.*\(newAmPriLowerLvlAdjdB=\)\([^\&]*\).*/\2/p"`
	newAmAnalogAudioBandwith=`echo $data_in | sed -n "s/.*\(newAmAnalogAudioBandwith=\)\([^\&]*\).*/\2/p"`
	newAmEnhancedPowerLevel=`echo $data_in | sed -n "s/.*\(newAmEnhancedPowerLevel=\)\([^\&]*\).*/\2/p"`
	newAmEnhancedCarriersOff=`echo $data_in | sed -n "s/.*\(newAmEnhancedCarriersOff=\)\([^\&]*\).*/\2/p"`
	newAmPidsPowerLevel=`echo $data_in | sed -n "s/.*\(newAmPidsPowerLevel=\)\([^\&]*\).*/\2/p"`
	newAmInterpolationFactor=`echo $data_in | sed -n "s/.*\(newAmInterpolationFactor=\)\([^\&]*\).*/\2/p"`
    
    
    cp -f /mnt/flash/exgine.cfg /tmp/exgine2.cfg
	
	if [ "X$newExgineMode" = "X1" ]; then
        sed -e	"s/\(exgineMode:[ \t]*\)[^ \t\#]*\(.*$\)/\11\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg    
	else
        cp -f /tmp/exgine2.cfg /tmp/exgine.cfg  
    fi


	if [ "$newAmSrvMode" != "1" -a "$newAmSrvMode" != "2" ]; then
			echo "Unsuported service AM  mode of $newAmSrvMode<BR>$errMsg";
			exit;
	fi


	val=`echo $newAmAnalogGain | sed -n 's/^\([0-9]*\)\.*[0-9]*$/\1/p'`;
    if [ "X$val" = "X" ]; then
			echo "Incorrect analog gain specified ($newAmAnalogGain) <BR>$errMsg";
			exit;
	fi
	if [ $val -ge 2 -o $val -lt 0 ]; then
			echo "Incorrect analog AM gain of $val<BR>$errMsg";
			exit;
	fi
    
    

	if [ "$newAmAnalogEnable" != "enabled" ]; then
		newAmAnalogEnable="disabled";
	fi
    
	if [ "$newDabEnable" != "enabled" ]; then
		newDabEnable="disabled";
	fi
    
    
	val=`echo $newAmIqScaleFactor | sed -n 's/^\([0-9]*\)\.*[0-9]*$/\1/p'`;
    if [ "X$val" = "X" ]; then
			echo "Incorrect IBOC gain specified ($newAmIqScaleFactor) <BR>$errMsg";
			exit;
	fi
	if [ $val -ge 24000 -o $val -lt 0 ]; then
			echo "Incorrect IBOC gain of $newAmIqScaleFactor<BR>$errMsg";
			exit;
	fi
    
	val=`echo $newAmDcOffset | sed -n 's/^\(-*[0-9]*\)\.*[0-9]*$/\1/p'`;
    if [ "X$val" = "X" ]; then
			echo "Incorrect DC offset specified ($newAmDcOffset) <BR>$errMsg";
			exit;
	fi
	if [ $val -ge 2 -o $val -le -2 ]; then
			echo "Incorrect DC offset of $newAmDcOffset<BR>$errMsg";
			exit;
	fi

	
	val=`echo $newAmDelay | sed -n 's/^\([0-9]*\)\.*[0-9]*$/\1/p'`;
    if [ "X$val" = "X" ]; then
			echo "Incorrect AM delay specified ($newAmDelay) <BR>$errMsg";
			exit;
	fi
    if [ $val -ge 32767 -o $val -lt 0 ]; then
			echo "Incorrect AM delay of $newAmDelay<BR>$errMsg";
			exit;
	fi
    
	val=`echo $newAmPriUpperLvlAdjdB | sed -n 's/^\(-*[0-9]*\)\.*[0-9]*$/\1/p'`;
    if [ "X$val" = "X" ]; then
			echo "Incorrect Primary Upper Level Adjust specified ($newAmPriUpperLvlAdjdB) <BR>$errMsg";
			exit;
	fi
	if [ $val -ge 20 -o $val -le -100 ]; then
			echo "Incorrect Primary Upper Level Adjust of $newAmPriUpperLvlAdjdB dB<BR>$errMsg";
			exit;
	fi
    
	val=`echo $newAmPriLowerLvlAdjdB | sed -n 's/^\(-*[0-9]*\)\.*[0-9]*$/\1/p'`;
    if [ "X$val" = "X" ]; then
			echo "Incorrect Primary Lower Level Adjust specified ($newAmPriLowerLvlAdjdB) <BR>$errMsg";
			exit;
	fi
	if [ "$val" -ge 20 -o "$val" -le -100 ]; then
			echo "Incorrect Primary Lower Level Adjust of $newAmPriLowerLvlAdjdB dB<BR>$errMsg";
			exit;
	fi
    

	if [ "$newAmAnalogAudioBandwith" -ne 0 -a "$newAmAnalogAudioBandwith" -ne 1 -a "$newAmAnalogAudioBandwith" -ne 2 ]; then
			echo "Incorrect Analog Audio Setting of $newAmAnalogAudioBandwith dB<BR>$errMsg";
			exit;
	fi

	if [ "$newAmEnhancedPowerLevel" -ne 0 -a "$newAmEnhancedPowerLevel" -ne 1 ]; then
			echo "Incorrect Emhanced Power Level of $newAmEnhancedPowerLevel dB<BR>$errMsg";
			exit;
	fi

	if [ "$newAmEnhancedCarriersOff" -ne 0 -a "$newAmEnhancedCarriersOff" -ne 1 ]; then
			echo "Incorrect Enhanced Carriers Off of $newAmEnhancedCarriersOff dB<BR>$errMsg";
			exit;
	fi
    
    
	if [ "$newAmPidsPowerLevel" -ne 0 -a "$newAmPidsPowerLevel" -ne 1 ]; then
			echo "Incorrect Pids Power Level of $newAmPidsPowerLevel dB<BR>$errMsg";
			exit;
	fi
    
	if [ "$newAmInterpolationFactor" -ne 1 -a "$newAmInterpolationFactor" -ne 2 -a "$newAmInterpolationFactor" -ne 4 ]; then
			echo "Incorrect AM Interpolation Factor of $newAmInterpolationFactor dB<BR>$errMsg";
			exit;
	fi


	
	#
	# Update configuration files
	#
	
	sed -e	"s/\(amSrvMode:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newAmSrvMode\2/" /tmp/exgine.cfg > /tmp/exgine2.cfg
	sed -e	"s/\(amAnalogGain:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newAmAnalogGain\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg
	sed -e	"s/\(amAnalogEnable:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newAmAnalogEnable\2/" /tmp/exgine.cfg > /tmp/exgine2.cfg
	sed -e	"s/\(amIqScaleFactor:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newAmIqScaleFactor\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg
	sed -e	"s/\(amDcOffset:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newAmDcOffset\2/" /tmp/exgine.cfg > /tmp/exgine2.cfg
	sed -e	"s/\(amDelay:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newAmDelay\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg
	sed -e	"s/\(amPriUpperLvlAdjdB:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newAmPriUpperLvlAdjdB\2/" /tmp/exgine.cfg > /tmp/exgine2.cfg
	sed -e	"s/\(amPriLowerLvlAdjdB:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newAmPriLowerLvlAdjdB\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg
	sed -e	"s/\(amAnalogAudioBandwith:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newAmAnalogAudioBandwith\2/" /tmp/exgine.cfg > /tmp/exgine2.cfg
	sed -e	"s/\(amEnhancedPowerLevel:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newAmEnhancedPowerLevel\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg
	sed -e	"s/\(amEnhancedCarriersOff:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newAmEnhancedCarriersOff\2/" /tmp/exgine.cfg > /tmp/exgine2.cfg
	sed -e	"s/\(amPidsPowerLevel:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newAmPidsPowerLevel\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg
	sed -e	"s/\(amInterpolationFactor:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newAmInterpolationFactor\2/" /tmp/exgine.cfg > /tmp/exgine2.cfg
	sed -e	"s/\(dabEnable:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newDabEnable\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg
    #cp -f /tmp/exgine2.cfg /tmp/exgine.cfg
	
	cat /proc/flash_write_enable > /dev/null
	mount -o remount,rw /mnt/flash
	
	if [ -e /mnt/flash/exgine.cfg ] ; then 
    		cp -f /mnt/flash/exgine.cfg /mnt/flash/exgine.cfg.bkup
	fi
	cp -f /tmp/exgine.cfg /mnt/flash/exgine.cfg
	
	
	mount -o remount,ro /mnt/flash
	cat /proc/flash_write_disable > /dev/null
	echo "<P><B>Note:</B> Changes have been applied.  A <A HREF="reboot.sh">reboot</A> is required for these changes to take effect.<P>";
fi

#
# Read configuration file settings
#

# exgine IP address
exgineMode=`sed -n "s/\(exgineMode:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
amSrvMode=`sed -n "s/\(amSrvMode:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
amAnalogGain=`sed -n "s/\(amAnalogGain:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
amAnalogEnable=`sed -n "s/\(amAnalogEnable:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
amIqScaleFactor=`sed -n "s/\(amIqScaleFactor:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
amDcOffset=`sed -n "s/\(amDcOffset:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
amDelay=`sed -n "s/\(amDelay:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
amPriUpperLvlAdjdB=`sed -n "s/\(amPriUpperLvlAdjdB:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
amPriLowerLvlAdjdB=`sed -n "s/\(amPriLowerLvlAdjdB:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
amAnalogAudioBandwith=`sed -n "s/\(amAnalogAudioBandwith:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
amEnhancedPowerLevel=`sed -n "s/\(amEnhancedPowerLevel:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
amEnhancedCarriersOff=`sed -n "s/\(amEnhancedCarriersOff:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
amPidsPowerLevel=`sed -n "s/\(amPidsPowerLevel:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
amInterpolationFactor=`sed -n "s/\(amInterpolationFactor:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
dabEnable=`sed -n "s/\(dabEnable:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;


################################################################################
# Build the HTML page
################################################################################
echo "<FORM METHOD=POST ACTION=amexgine.sh>"

echo "<TABLE WIDTH=80% CELLSPACING=0  CELLPADDING=4>"
echo "<TR><TD bgcolor=\"#09254a\"><FONT color=gray FACE=\"Verdana\"><B>AM Exgine System Parameters</B></FONT></TD>";
echo "<TD ALIGN=right bgcolor=\"#09254a\"><A HREF=\"/amexgine_hlp.html\" TRAGET=_blank><FONT color=gray FACE=\"Verdana\"><B>[help]</b></FONT></A></TD></TR>";
echo "<TR><TD VALIGN=top><B>AM Operating mode </B></TD><TD>"

if [ "X$exgineMode" = "X1" ]; then
    echo "Set to AM Mode"
else
	echo "Not set to AM Mode. Switch to AM mode?<BR>"
    echo "<INPUT TYPE=RADIO NAME=newExgineMode VALUE=\"1\" checked> yes<BR>"
    echo "<INPUT TYPE=RADIO NAME=newExgineMode VALUE=\"other\"> no"
    
fi

echo "</TD></TR>";

echo "<TR><TD VALIGN=top><B>Default Service Mode</B></TD><TD>"

if [ "X$amSrvMode" = "X1" ]; then
	default_ma1="CHECKED";
	default_ma2="";
else
	default_ma1="";
	default_ma2="CHECKED";
fi

    echo "<INPUT TYPE=RADIO NAME=newAmSrvMode VALUE=\"1\" $default_ma1> MA1 - hybrid<BR>"
    echo "<INPUT TYPE=RADIO NAME=newAmSrvMode VALUE=\"2\" $default_ma2> MA3 - all digital"


echo "</TD></TR>";

echo "<TR><TD VALIGN=top><B>Analog Gain (0.0 - 2.0)</B></TD><TD><INPUT TYPE=text NAME=newAmAnalogGain VALUE=\"$amAnalogGain\"></TD></TR>";


    echo "<TR><TD VALIGN=top><B>Digital Carriers</B></TD><TD>"
    
    if [ "$dabEnable" = "enabled" ]; then
        default_dab_on="CHECKED";
        default_dab_off="";
    else
        default_dab_on="";
        default_dab_off="CHECKED";
    fi
    
    echo "<INPUT TYPE=RADIO NAME=newDabEnable VALUE=\"enabled\" $default_dab_on> on<BR>"
    echo "<INPUT TYPE=RADIO NAME=newDabEnable VALUE=\"disabled\" $default_dab_off> off"
    echo "</TD></TR>";

    echo "<TR><TD VALIGN=top><B>Analog Transmission</B></TD><TD>"
    
    if [ "$amAnalogEnable" = "enabled" ]; then
        default_analog_on="CHECKED";
        default_analog_off="";
    else
        default_analog_on="";
        default_analog_off="CHECKED";
    fi
    
    echo "<INPUT TYPE=RADIO NAME=newAmAnalogEnable VALUE=\"enabled\" $default_analog_on> on<BR>"
    echo "<INPUT TYPE=RADIO NAME=newAmAnalogEnable VALUE=\"disabled\" $default_analog_off> off"
    echo "</TD></TR>";


echo "<TR><TD VALIGN=top><B>Digital Gain Factor(0 - 32000)</B></TD><TD><INPUT TYPE=text NAME=newAmIqScaleFactor VALUE=\"$amIqScaleFactor\"></TD></TR>";
echo "<TR><TD VALIGN=top><B>AM DC Offset</B></TD><TD><INPUT TYPE=text NAME=newAmDcOffset VALUE=\"$amDcOffset\"></TD></TR>";
echo "<TR><TD VALIGN=top><B>AM Delay</B></TD><TD><INPUT TYPE=text NAME=newAmDelay VALUE=\"$amDelay\"></TD></TR>";
echo "<TR><TD VALIGN=top><B>Upper Primary Level Adjust</B></TD><TD>"
echo "<INPUT TYPE=text NAME=newAmPriUpperLvlAdjdB VALUE=\"$amPriUpperLvlAdjdB\"> dB<BR>"
echo "</TD></TR>";
echo "<TR><TD VALIGN=top><B>Lower Primary Level Adjust</B></TD><TD>"
echo "<INPUT TYPE=text NAME=newAmPriLowerLvlAdjdB VALUE=\"$amPriLowerLvlAdjdB\"> dB"
echo "</TD></TR>";



    echo "<TR><TD VALIGN=top><B>Analog Bandwidth</B></TD><TD>"
    
    if [ "X$amAnalogAudioBandwith" = "X0" ]; then
        default_5k="CHECKED";
        default_8k="";
        default_bp="";
    elif [ "X$amAnalogAudioBandwith" = "X1" ]; then
        default_5k="";
        default_8k="CHECKED";
        default_bp="";
    else
        default_5k="";
        default_8k="";
        default_bp="CHECKED";
    fi
    
    echo "<INPUT TYPE=RADIO NAME=newAmAnalogAudioBandwith VALUE=\"0\" $default_5k> 5 kHz<BR>"
    echo "<INPUT TYPE=RADIO NAME=newAmAnalogAudioBandwith VALUE=\"1\" $default_8k> 8 kHz<BR>"
    echo "<INPUT TYPE=RADIO NAME=newAmAnalogAudioBandwith VALUE=\"2\" $default_bp> bypassed"
    echo "</TD></TR>";

    echo "<TR><TD VALIGN=top><B>Enhanced Power Levels</B></TD><TD>"
    
    if [ "X$amEnhancedPowerLevel" = "X0" ]; then
        default_high="CHECKED";
        default_low="";
    else
        default_high="";
        default_low="CHECKED";
    fi
    
    echo "<INPUT TYPE=RADIO NAME=newAmEnhancedPowerLevel VALUE=\"0\" $default_high> high<BR>"
    echo "<INPUT TYPE=RADIO NAME=newAmEnhancedPowerLevel VALUE=\"1\" $default_low> low"
    echo "</TD></TR>";


    echo "<TR><TD VALIGN=top><B>Enhanced Carriers</B></TD><TD>"
    
    if [ "X$amEnhancedCarriersOff" = "X0" ]; then
        default_high="CHECKED";
        default_low="";
    else
        default_high="";
        default_low="CHECKED";
    fi
    
    echo "<INPUT TYPE=RADIO NAME=newAmEnhancedCarriersOff VALUE=\"0\" $default_high> enabled<BR>"
    echo "<INPUT TYPE=RADIO NAME=newAmEnhancedCarriersOff VALUE=\"1\" $default_low> disabled"
    echo "</TD></TR>";

    echo "<TR><TD VALIGN=top><B>PIDS Power Levels</B></TD><TD>"
    
    if [ "X$amPidsPowerLevel" = "X0" ]; then
        default_high="CHECKED";
        default_low="";
    else
        default_high="";
        default_low="CHECKED";
    fi
    
    echo "<INPUT TYPE=RADIO NAME=newAmPidsPowerLevel VALUE=\"0\" $default_high> high<BR>"
    echo "<INPUT TYPE=RADIO NAME=newAmPidsPowerLevel VALUE=\"1\" $default_low> low"
    echo "</TD></TR>";

    echo "<TR><TD VALIGN=top><B>Output sample rate</B></TD><TD>"
    
    if [ "X$amInterpolationFactor" = "X1" ]; then
        default_1x="CHECKED";
        default_2x="";
        default_4x="";
    elif [ "X$amInterpolationFactor" = "X2" ]; then
        default_1x="";
        default_2x="CHECKED";
        default_4x="";
    else
        default_1x="";
        default_2x="";
        default_4x="CHECKED";
    fi
    
    echo "<INPUT TYPE=RADIO NAME=newAmInterpolationFactor VALUE=\"1\" $default_1x> 1X - 46.512 kSa<BR>"
    echo "<INPUT TYPE=RADIO NAME=newAmInterpolationFactor VALUE=\"2\" $default_2x> 2X - 93.024 kSa<BR>"
    echo "<INPUT TYPE=RADIO NAME=newAmInterpolationFactor VALUE=\"4\" $default_4x> 4X - 186.048 kSa"
    echo "</TD></TR>";



echo "<TR></TR></TABLE>";
echo "<INPUT TYPE=submit VALUE=\"Accept Changes\" >"
echo "<INPUT TYPE=reset VALUE=\"Clear Changes\" >"
echo "</FORM>"
echo "</BODY>"

















