#!/bin/sh
echo "Content-type: text/html";
echo;
echo "<HTML><TITLE>Edit E2X Transport Mode</TITLE><BODY>";
cd /mnt/flash

errMsg="<BR>Please use your browser's <B>back</B> button to correct the error.<BR>";

#
# Read CGI data
#
read data_in

#
# Parse the input data
#
if [ "X$data_in" != "X" ]; then
	#
	# Input checking
	#
	#echo "Got $data_in"
	newReqFp=`echo $data_in | sed -n "s/.*\(newReqFp=\)\([^\&]*\).*/\2/p"`
	newProtocol=`echo $data_in | sed -n "s/.*\(newProtocol=\)\([^\&]*\).*/\2/p"`
	newExgineIp=`echo $data_in | sed -n "s/.*\(newExgineIp=\)\([^\&]*\).*/\2/p"`
	newNetmask=`echo $data_in | sed -n "s/.*\(newNetmask=\)\([^\&]*\).*/\2/p"`
	newGateway=`echo $data_in | sed -n "s/.*\(newGateway=\)\([^\&]*\).*/\2/p"`
	newExporterIp=`echo $data_in | sed -n "s/.*\(newExporterIp=\)\([^\&]*\).*/\2/p"`
	newFifoInitThreshold=`echo $data_in | sed -n "s/.*\(newFifoInitThreshold=\)\([^\&]*\).*/\2/p"`
	newE2xTestMode=`echo $data_in | sed -n "s/.*\(newE2xTestMode=\)\([^\&]*\).*/\2/p"`
	
	if [ "$newReqFp" != "enabled" ]; then
		newReqFp="disabled";
	fi

	if [ "$newProtocol" != "1" ]; then
		newProtocol="0";
	fi
	
	val=`echo $newFifoInitThreshold | sed -n 's/^\([0-9]*\)$/\1/p'`;
	if [ "X$val" = "X" ]; then
		echo "Invalid receive buffer depth ($newFifoInitThreshold)<BR>$errMsg";
		exit;
	fi
	if [ $val -lt 4 ]; then
		echo "Invalid receive buffer depth > 3 ($newFifoInitThreshold)<BR>$errMsg";
		exit;
	fi
	if [ $val -gt 399 ]; then
		echo "Invalid receive buffer depth < 400  ($newFifoInitThreshold)<BR>$errMsg";
		exit;
	fi

	val=`echo $newE2xTestMode | sed -n 's/^\([0-9]*\)$/\1/p'`;
	if [ $val -lt 6 ]; then
        newE2xTestMode='0';
	fi
	if [ $val -gt 500 ]; then
        newE2xTestMode='100';
	fi

	
    
	# check IP addresses
    i=1;
    while [ $i -lt 5 ]; do
		byte=`echo $newExgineIp | sed -n 's/^\([0-9]*\).\([0-9]*\).\([0-9]*\).\([0-9]*\)$/\'$i'/p'`;
		if [ "X$byte" = "X" ]; then
			echo "Exgine IP address misconfiguration ($newExgineIp)<BR>$errMsg";
			exit;
		fi
		if [ $byte -gt 255 ]; then
			echo "Exgine IP address misconfiguration ($newExgineIp)<BR>$errMsg";
			exit;
		fi

		byte=`echo $newNetmask | sed -n 's/^\([0-9]*\).\([0-9]*\).\([0-9]*\).\([0-9]*\)$/\'$i'/p'`;
		if [ "X$byte" = "X" ]; then
			echo "Netmask misconfiguration ($newNetmask)<BR>$errMsg";
			exit;
		fi
		if [ $byte -gt 255 ]; then
			echo "Netmask misconfiguration ($newNetmask)<BR>$errMsg";
			exit;
		fi

		byte=`echo $newGateway | sed -n 's/^\([0-9]*\).\([0-9]*\).\([0-9]*\).\([0-9]*\)$/\'$i'/p'`;
		if [ "X$byte" = "X" ]; then
			echo "Gateway misconfiguration ($newGateway)<BR>$errMsg";
			exit;
		fi
		if [ $byte -gt 255 ]; then
			echo "Gateway misconfiguration ($newGateway)<BR>$errMsg";
			exit;
		fi

		byte=`echo $newExporterIp | sed -n 's/^\([0-9]*\).\([0-9]*\).\([0-9]*\).\([0-9]*\)$/\'$i'/p'`;
		if [ "X$byte" = "X" ]; then
			echo "Exporter IP misconfiguration ($newExporter)<BR>$errMsg";
			exit;
		fi
		if [ $byte -gt 255 ]; then
			echo "Exporter IP misconfiguration ($newExporter)<BR>$errMsg";
			exit;
		fi
		
		
		let i=i+1;
	done
	
	
			
	#echo "<BR>"
	#echo "newReqFp: $newReqFp<BR>"
	#echo "newExgineIp: $newExgineIp<BR>"	
	#echo "newNetmask: $newNetmask<BR>"
	#echo "newGateway: $newGateway<BR>"
	#
	# Update configuration files
	#
    
	killall -q -2 exgined
    
	cp -f /mnt/flash/exgine.cfg /tmp/exgine.cfg
	
	sed -e	"s/^\(requireFpInfo:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newReqFp\2/" /tmp/exgine.cfg > /tmp/exgine2.cfg
	sed -e	"s/^\(exgineIp:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newExgineIp\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg
	sed -e	"s/^\(netmask:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newNetmask\2/" /tmp/exgine.cfg > /tmp/exgine2.cfg
	sed -e	"s/^\(gateway:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newGateway\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg
	sed -e	"s/^\(protocol:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newProtocol\2/" /tmp/exgine.cfg > /tmp/exgine2.cfg
	sed -e	"s/^\(exporterIp:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newExporterIp\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg	
    sed -e	"s/^\(fifoInitThreshold:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newFifoInitThreshold\2/" /tmp/exgine.cfg > /tmp/exgine2.cfg	
    sed -e	"s/^\(e2xTestMode:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newE2xTestMode\2/" /tmp/exgine2.cfg > /tmp/exgine.cfg	
        
	cat /proc/flash_write_enable > /dev/null
	mount -o remount,rw /mnt/flash
	
	if [ -e /mnt/flash/exgine.cfg ] ; then 
		cp -f /mnt/flash/exgine.cfg /mnt/flash/exgine.cfg.bkup
	fi
	cp -f /tmp/exgine.cfg /mnt/flash/exgine.cfg
	
	mount -o remount,ro /mnt/flash
	cat /proc/flash_write_disable > /dev/null
	
	echo "<P><B>Note:</B> Changes have been applied.  A <A HREF="reboot.sh">reboot</A> is required for these changes to take effect.<P>";
	
fi

#
# Read configuration file settings
#

# exgine IP address
reqFp=`sed -n "s/^\(requireFpInfo:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
protocol=`sed -n "s/^\(protocol:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
exgineIp=`sed -n "s/^\(exgineIp:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
netmask=`sed -n "s/^\(netmask:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
gateway=`sed -n "s/^\(gateway:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
exporterIp=`sed -n "s/^\(exporterIp:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
fifoInitThreshold=`sed -n "s/^\(fifoInitThreshold:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
e2xTestMode=`sed -n "s/^\(e2xTestMode:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;


#
# Build the HTML page
#
echo "<FORM METHOD=POST ACTION=netcfg.sh>"

echo "<TABLE WIDTH=80% CELLSPACING=0 CELLPADDING=4>"
echo "<TR><TD bgcolor=\"#09254a\"><FONT color=gray FACE=\"Verdana\"><B>Exgine Network Configuration</B></FONT></TD>";
echo "<TD ALIGN=right bgcolor=\"#09254a\"><A HREF=\"/netcfg_hlp.html\" TRAGET=_blank><FONT color=gray FACE=\"Verdana\"><B>[help]</B></FONT></A></TD></TR>";
echo "<TR><TD><B>Use front panel network settings </B></TD><TD>"

if [ "$reqFp" = "enabled" ]; then
	defaultyes="CHECKED";
	defaultno="";
else
	defaultyes="";
	defaultno="CHECKED";
fi

echo "<INPUT TYPE=RADIO NAME=newReqFp VALUE=\"enabled\" $defaultyes> yes"
echo "<INPUT TYPE=RADIO NAME=newReqFp VALUE=\"disabled\" $defaultno> no"
echo "</TD></TR>";


echo "<TR><TD VALIGN=top><B>Receive E2X protocol mode </B><BR>"
echo "(Nautel E2X protocol can always be received)</TD><TD VALIGN=top>"

if [ "$protocol" = "1" ]; then
	defaulttcp="CHECKED";
	defaultucp="";
else
	defaulttcp="";
	defaultudp="CHECKED";
fi


echo "<NOBR><INPUT TYPE=RADIO NAME=newProtocol VALUE=\"0\" $defaultudp> UDP (uni-directional)</NOBR><BR>"
echo "<NOBR><INPUT TYPE=RADIO NAME=newProtocol VALUE=\"1\" $defaulttcp> TCP/IP (bi-directional)</NOBR><BR>"
echo "</TD></TR>";


echo "<TR><TD><B>IP Address</B></TD><TD><INPUT TYPE=text NAME=newExgineIp VALUE=\"$exgineIp\"></TD></TR>";
echo "<TR><TD><B>Netmask</B></TD><TD><INPUT TYPE=text NAME=newNetmask VALUE=\"$netmask\"></TD></TR>";
echo "<TR><TD><B>Default Gateway</B></TD><TD><INPUT TYPE=text NAME=newGateway VALUE=\"$gateway\"></TD></TR>";
echo "<TR><TD><B>Exporter IP</B></TD><TD><INPUT TYPE=text NAME=newExporterIp VALUE=\"$exporterIp\"></TD></TR>";
echo "<TR><TD><B>E2X Receive Buffer Depth</B></TD><TD><INPUT TYPE=text NAME=newFifoInitThreshold VALUE=\"$fifoInitThreshold\"></TD></TR>";

echo "<TR><TD><B>Reliable HD Transport Test Mode</B></TD><TD>";

    if [ "X$e2xTestMode" = "X100" ]; then
        newE2xTestModeSel0="";
        newE2xTestModeSel10="";
        newE2xTestModeSel50="";
        newE2xTestModeSel100="CHECKED";
    elif [ "X$e2xTestMode" = "X50" ]; then
        newE2xTestModeSel0="";
        newE2xTestModeSel10="";
        newE2xTestModeSel50="CHECKED";
        newE2xTestModeSel100="";
    elif [ "X$e2xTestMode" = "X10" ]; then
        newE2xTestModeSel0="";
        newE2xTestModeSel10="CHECKED";
        newE2xTestModeSel50="";
        newE2xTestModeSel100="";
    else
        newE2xTestModeSel0="CHECKED";
        newE2xTestModeSel10="";
        newE2xTestModeSel50="";
        newE2xTestModeSel100="";
    fi
    
echo "<INPUT TYPE=RADIO NAME=newE2xTestMode VALUE=\"0\" $newE2xTestModeSel0> disabled (default)<BR>";
echo "<INPUT TYPE=RADIO NAME=newE2xTestMode VALUE=\"10\" $newE2xTestModeSel10> discard 1 in 10 packets<BR>";
echo "<INPUT TYPE=RADIO NAME=newE2xTestMode VALUE=\"50\" $newE2xTestModeSel50> discard 1 in 50 packets<BR>";
echo "<INPUT TYPE=RADIO NAME=newE2xTestMode VALUE=\"100\" $newE2xTestModeSel100> discard 1 in 100 packets";
echo "</TD></TR>";

echo "<TR></TR></TABLE>";
echo "<INPUT TYPE=submit VALUE=\"Accept Changes\" >"
echo "<INPUT TYPE=reset VALUE=\"Clear Changes\" >"
echo "</FORM>"
echo "<P><B>Note:</B> <BR> Submitting configuration changes will suspend exgine operation until the system is restarted.<P>";
echo "</BODY>"
echo "</HTML>"

















